
#ifndef _bm_h_
#define _bm_h_


#define CHARCOUNT 256
#define ASIZE CHARCOUNT

typedef struct boyermoore_struct {
  int  skipB[CHARCOUNT];
  int* skipG;
  unsigned char*   needle;
  size_t  needle_len;
} bm_info;


/* initialization */
bm_info* bm_init(char* pattern, size_t pattern_len);

/* main boyer moore search */
char* BM(unsigned char *haystack, int hay_len, bm_info* bmi);

/* cleanup */
void bm_free(bm_info* bmi);

#endif
