/********************************************************************************
 *                Conficker Memory Scanner and Removal
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/


#ifndef _SIGNATURES_H_
#define _SIGNATURES_H_

#include <windows.h>

u_char signature_conficker_A[] = "\xCF\xF0\x7B\x61\x89\xD7\x16\xE8\x1B\x09\xED\x31\x45\xFE\x2E\xE7\x8A\x24\xB9\x56\xF6\x73\x41\x36\x78\xEF\x37\x50\xDF\xEC\x86\xCA\x4F\xE2\x96\x4B\xC3\xE6\xF4\x50\xBA\x16\x56\xE8\x4E\x76\xF2\x5B\x72\x45\x57\x98\x7A\x07\x0B\x97\x15\x17\xE9\xAB\xF6\x6D\x13\x56\xDE\x66\x1A\x55\xAE\xAE\x9E\x94\x53\xEE\x60\x25\x34\xFC\x01\xCB\xF7\x66\x1D\xF4\xB0\xE9\x1D\x6F\xE9\xA9\x1B\x82\xC1\xA3\x5C\x6E\xE3\xDA\x61\x65\x28\xAB\x36\x6A\xA5\x3E\xE9\xEE\x0A\xC1\x3A\xE2\x27\x43\xF6\x1E\x0B\x03\x2A\x3C\x9B\x91\xFE\xE9\x40\x76\xBF\x25";

u_char signature_conficker_B[] = "\xE7\xA7\x2D\xF5\x45\xCA\x12\x49\xE6\x44\x1E\xD6\x72\x4C\x1B\xBA\x3C\x72\xF0\x8B\x4B\xEB\x75\xF3\x5E\xE8\x44\xCD\x87\x56\xE9\x21\xE6\x06\x34\x33\x76\x49\x93\x42\xEC\xE8\x03\x36\x19\xA6\xAD\x4D\x12\x59\x7F\x96\x01\x85\x41\x25\xCB\xE2\x83\x7E\x72\xDF\x85\xB3\xDD\xE1\x59\xFB\x97\x78\x9A\x2D\xB2\xB6\x3D\xE9\x58\x52\x45\x39\x1B\x90\xC8\x9F\xD7\x5C\x2B\x42\xDE\xA6\x6A\xD8\x03\xD0\xF2\x4C\xAF\x72\x24\x2E\x9D\x8C\xF3\x4D\x2F\x2F\x4D\xF2\x49\xD6\x89\x29\xA2\xC9\xC6\xFF\xF2\x5F\x98\xB6\x68\x09\xAD\x92\x10\x70\xD5\x10\xEA\x1C\xDA\xB6\xBC\xD4\x03\xCC\x8D\x9E\x8E\x57\x8C\xCF\xFC\xBC\x5B\xC3\x9E\x31\x5B\xDA\x08\x8A\x93\x26\x80\xBF\xD2\xDB\x45\x80\x83\x33\x87\xAF\x69\xC2\xF6\x5F\x15\x99\x34\x14\xCB\x0F\x88\xCC\x44\x29\xE9\x93\x45\x9E\x7E\xF9\x12\x87\x8A\x93\x8E\x33\x43\xBB\x0C\x40\x5B\x60\x4C\x86\x40\x31\x17\x99\x65\x13\xE4\x6C\xC2\x8A\xE5\xA4\x30\xD9\xF3\xD6\x6A\xBB\xEB\xDF\xDA\x02\xEC\x6D\x38\x7E\x23\xEE\x11\x68\x8A\x62\x7D\xA8\x93\x93\x9E\xC6\xDC\x7B\xF1\x23\x5D\x66\x72\x39\xC8\x3D\xE5\x56\xC3\x20\xD9\xA8\x9A\x25\x35\xE4\x3B\x99\xD4\x7E\x61\xD1\xD7\x74\x50\xE3\x6A\xEB\x49\x5A\x31\x3D\x21\xDE\x29\x4A\xCD\x30\xFC\xD1\xFD\xD7\x98\x73\x60\x4B\xA6\x53\x08\x5D\xF9\xEE\x05\xE6\x21\x97\xED\xD9\xB7\xD6\xBC\x00\x34\xB1\x76\x6B\xBD\x26\x60\x8A\x2C\x1C\xB6\xE6\x58\x2D\x47\x4D\x40\x09\x5B\x83\xB1\x9D\x3C\x98\x8E\xA2\x2D\x9E\x5D\x7A\x07\xF1\x0D\xC8\x1B\x26\x47\xB0\x1A\x1C\x70\x08\x76\x4C\xC2\x9C\xCF\x3A\xF3\x0E\x1E\xC6\x00\xA8\x15\xCB\x47\x92\x7E\x1D\xF9\x07\x42\xAA\x92\x49\xDC\x04\x71\xED\xD6\xE7\xDC\xE6\xAD\x3C\xBD\x25\x18\x32\xFA\xEC\xFA\xB7\xA5\xFB\xCC\xA1\x49\x52\xBA\x30\x60\xA7\xD3\xB0\xA3\x95\xE5\xF2\xDA\x61\xBD\x27\xD2\x97\xC0\xD8\x66\x33\x37\x04\x13\xD2\x36\x9D\x3F\xCB\x24\x79\x6B\x2E\x69\x22\xE1\x0B\xAD\xC1\x5B\x48\x8A\xE1\xD5\x00\x87\x37\x44\x06\xF5\xAE\x4C\x74\x4B\x20\x0F\xA3\x57\x63\x08\xD4\x57\xEB\xF0\x3A\xE3\x1A\x03\xC4\xDF\x9A\x17\x2D\x7F\xFD\x1F\x44\x71\xDA\x49\xB7\xBA\x3F\x26\xB5\xDD\x9C\xFE\xCA\x18\x70\xDB\xEC\x99\x63\x84\x96\x30\x10\x80\x4C\x33\x73\x4D\xBC\xB2\xC3\x79\x2C\x83\x68\xCD\x41\x5C\x45\xED\x7D\xE7\xBE\xA8\x88";

u_char signature_conficker_C[] = "\x13\xE5\xA4\x19\xAD\x58\x46\x33\x10\x1E\xFE\xC1\xA1\x96\x4F\xB1\x18\xFB\xE1\x49\x20\x32\x9C\x17\xE8\x1C\x7C\xBC\x6D\x81\x31\xC9\xDB\x8D\x7D\xBC\xA1\xBB\x94\xE4\x21\x04\x7D\x30\xAA\xF9\x67\x8C\x78\xA6\x41\x47\xCA\x08\x57\xB9\x52\x00\xA9\x2B\xE0\x78\xD7\xFC\x5A\x57\xFB\x7C\xD9\xD0\x16\xE2\x2E\x2C\xDE\xF6\xDB\x84\x94\x43\xE7\xEE\x72\x1C\x86\x7E\x81\x95\x59\xCE\x39\xBB\xA2\x20\xA0\x81\x63\x03\x09\x3D\x9C\xEF\x5F\xEE\x03\x8B\xD9\x56\x21\xA8\xC4\xFA\xB5\xB1\x69\x20\x74\x30\xB5\x1C\xEA\x83\x04\x78\x50\x78\xAC\x1C\x8C\x54\x5D\x2B\xE3\x92\x75\xBD\xD9\x78\x5E\xEB\x21\x43\x9B\xA6\x16\x89\xD4\x6B\x0B\x0F\x0D\x6A\x15\x47\xF8\x19\x50\x41\x62\x2C\x9E\xD8\x9A\x56\x3B\x41\x7A\xC4\x5A\x44\xAF\xFB\xD6\x7D\xF9\x1C\xC0\x46\xA3\xF5\x81\x49\xBA\xD6\xE1\x06\xA8\x93\xF6\xE7\x87\x83\x62\xE8\xC0\xBC\x2D\x18\x7A\x69\x1E\x1A\xF5\x19\x5A\xB9\xCE\x7A\x34\xDC\xA0\x3A\x2E\xEE\x6B\x12\xB2\xF0\x2D\x2E\x87\x6D\x5F\x2D\xF5\x97\xBC\xF0\x53\x1A\x30\xC5\x6D\xC5\xA4\xA2\x28\xBE\x88\xAD\xE1\x79\x06\x6E\x3C\x90\xF3\x36\xF9\x2F\xF8\x05\x3B\x5B\xEA\xC3\xD3\x01\xE5\x67\x6C\x4C\x28\x7E\x35\xB3\xCD\x6E\x33\xD3\xD3\x20\x2E\x09\xCF\x30\x79\x4A\x41\x03\x62\x76\x1D\x92\xB2\xA4\x34\x88\x09\x44\x14\x55\x14\xE8\xEF\xF0\xFC\xCB\x82\xE0\x04\x50\x42\x36\xDC\x3D\xB8\x92\xE9\xAB\x13\x5A\x7B\x0E\x07\xA4\xEB\x71\x69\x1C\x03\xA9\x0E\x5E\x29\x43\x57\xD4\xA8\xE0\x71\xBD\x47\x6E\x73\xCC\x82\x0B\x63\x81\x89\x6F\xAC\x5E\x59\x16\x3F\xE2\xD2\xDC\xA4\xBD\xF7\x77\xEA\x0A\xF3\xCC\x6F\x4D\x51\xDB\x7C\x94\x7D\x57\x5E\x1B\xA6\xA2\x18\xE1\xC5\xB6\xE2\x20\x8E\x6C\x11\x4F\xC9\x1E\xF6\x56\x93\x8F\x56\x62\xA0\x11\x86\x1F\x1D\x1D\x2D\xD7\x2A\xE1\x30\x31\x30\x1C\xA8\xBF\x28\x0D\x0E\x90\xDA\x2D\x54\xB7\x8C\x03\x44\x00\x7D\x5B\xAB\xC2\x5F\x51\x34\xE0\xA5\xBF\x2D\xED\xC3\x28\xD4\xBB\x59\xB5\xF2\x5E\xFD\x5A\x5B\x9A\xE9\x39\x62\xB4\x99\x4E\x35\x09\xE2\xA2\xB1\x81\x2B\x2F\x4B\xDB\x3E\x76\x62\x22\x52\xFD\x79\x5B\x6E\x53\x70\x3C\xBE\x9E\x4D\xAB\x54\xD3\x9E\x62\xFF\x59\x7A\x60\xFC\x78\x48\x1E\x05\x2F\xCB\x1C\xF9\x5F\x23\x91\xFE\x7E\x42\xE2\x88\xB0\xD3\x33\x87\x41\x00\x72\x4F\x94\x63\x22\x67\xB9\xA2\x20";

u_char signature_conficker_D[] = "\x91\xC4\x3C\x28\xE0\xB1\xCF\xC9\x9A\xBF\x4A\xF5\x92\x5D\xE1\x09\xD1\x4F\x8C\x04\xC5\xD7\x3C\xEB\x78\xD7\x7C\xAD\x6D\x20\x3F\x32\x99\xE3\x49\xC6\x7B\xCB\xD6\x8E\x06\x05\xF7\x68\xFB\xEF\x82\xB7\xE9\x4F\xAF\x47\x1D\x06\x3E\xA6\xCC\xA6\xF6\xA6\xFA\x67\xF2\x02\xE5\xF8\x83\x76\x93\xC2\xC5\x61\x5C\x03\x33\x0D\x8C\xEB\x46\xE9\xDD\x3C\x9B\xEE\x8D\x65\xBF\x67\x92\xF7\xE6\xAC\xAC\x69\xEA\x7B\x13\x0F\xCA\x17\xA8\x11\x6F\xB9\x27\xAF\xC1\xC4\x67\xFF\x0E\x32\xCB\x96\xC2\x6C\x75\x1E\x5C\x34\x3C\x2C\x18\x7B\x93\xA6\x60\x0E\xEA\xB5\x53\x70\xE6\x69\xE8\x73\xE6\x71\x89\x09\x05\x98\x78\x40\xE9\xD3\x74\x5B\xCF\x3F\x9E\xA6\xC1\x13\xDF\xE1\xFB\x88\x0A\x74\x4E\xBA\x3E\x20\xC7\xED\x4B\x13\x25\xD1\x1B\xED\x2E\x84\x54\x6D\x57\x7E\x8D\x4B\x6A\x09\xEA\x20\x3B\x83\x5B\x89\x2B\xED\xEA\xBE\x09\x06\xAA\xE9\x42\xFB\xBB\x1C\x5D\x24\xD3\xD7\xF4\x28\x4D\x7E\x9B\xFF\x74\x6E\xBB\x5D\x91\x4C\x51\x76\x35\x49\x89\x7D\x7D\xCC\xA9\x33\xD7\x11\x6C\x27\x5A\xBA\xCB\x46\xFC\x60\xE0\xF8\xB9\xF5\x9E\x8B\x0C\xFD\x23\x3A\x4C\x62\xCE\x10\x39\xD6\xCF\xCC\x13\x94\xC5\xEB\x81\x1C\x00\xC6\x7B\x63\x5C\x03\x24\xF5\x72\x5E\x6D\x29\x81\xB9\xD3\x64\x9A\x07\x69\x20\x0A\x58\xC0\xD3\x17\x76\xDE\x11\x97\xC7\xBA\xAC\xFC\x3E\xAF\x39\x63\x77\x0F\xC1\x45\x35\x95\x2C\x19\x52\x25\xC8\xB5\xBB\xED\x80\x07\xBA\x78\x4E\x49\x6B\xA9\x07\x17\xE0\x5E\x89\x8A\xAE\xDF\xB4\x17\x60\x47\x56\x13\xFA\xA2\x2D\x8E\x79\x42\x02\x51\xBC\x40\x29\xE2\xFA\x52\x0E\x15\x54\x30\x4B\x30\x99\xD6\x6E\x7E\x77\xD0\x0E\x63\xB7\xE4\x2B\x59\x82\x26\xC9\xF5\xBD\xF0\x30\x5D\x7A\x05\xFE\xAB\xEF\xFA\x20\x96\x34\x90\x22\xD0\xEB\xC5\x86\x86\x16\xD9\x60\x97\x63\x74\x8A\xA3\xDE\xED\x65\xBA\x27\x73\xC5\x5E\x99\x48\xD7\xD6\x5C\x09\x5B\x92\xA7\xA4\xBA\x93\x81\x41\xE3\x40\x8F\x51\x77\x7F\x82\x8C\x30\xD6\x94\xE9\x01\xF6\x91\xF1\x74\xDC\xD1\x5E\x4C\x8E\x30\xC9\x4F\xCB\xB5\xB5\xB0\xE6\x70\x28\x61\x97\xF8\xA6\xAF\xCB\x86\x7C\x26\xF6\xD8\xCC\xCA\x02\x54\x17\x02\xCA\x81\xA1\xB3\x42\xA1\x03\xD1\x10\x5A\x41\x94\xEA\x24\xC9\xA9\x09\xCA\xC5\xE8\x19\x41\xA1\x40\x98\xD8\x39\x0A\xC1\x3E\xB9\xFC\xD2\x6C\x45\xB5\x6B\xC6\xAE\xC1\x5E\x1F\x73\x7A";

#endif
